//+------------------------------------------------------------------+
//|                                            TrailingByShadows.mq4 |
//|                                            I_D                   |
//|                                            http://www.mymmk.com/ |
//+------------------------------------------------------------------+
#property copyright "I_D, modified by evillive (https://www.mql5.com/ru/users/evillive)"
#property link      "http://www.mymmk.com/"
#property strict

extern   ENUM_TIMEFRAMES   tf = PERIOD_CURRENT;         // 
extern   int   Bars_n = 3;         // - ,    
extern   int   Indent = 3;         //    ,    
extern   bool  Trlinloss = false;  //       (    )

//+------------------------------------------------------------------+
//|    N                                        |
//|             |
//| ()  ,     :|
//|  ,           |
//| ( 1  )   () -   . (.)  |
//| ,     ( 0),      |
//| trlinloss ,              |
//| "-  .                                 |
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void OnTick()
{
   for (int i=OrdersTotal()-1;i>=0;i--)
   {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      if ((OrderType()<2)&&OrderMagicNumber()==0)
      {
         TrailingByShadows(OrderSymbol(),OrderTicket(),tf,Bars_n,Indent,Trlinloss); 
      }
   }
}
//+------------------------------------------------------------------+

void TrailingByShadows(string smb, int ticket,int tmfrm,int bars_n, int indent,bool trlinloss)
{  
   
   double new_extremum=0,newsl=0;
   
   double point=MarketInfo(smb,MODE_POINT),
          bid=MarketInfo(smb,MODE_BID),
          ask=MarketInfo(smb,MODE_ASK),
          typ=OrderType(),
          osl=OrderStopLoss(),
          otp=OrderTakeProfit(),
          oop=OrderOpenPrice();
    int  digits=(int)MarketInfo(smb,MODE_DIGITS),
         stoplevel=(int)MarketInfo(smb,MODE_STOPLEVEL),
         spread=(int)MarketInfo(smb,MODE_SPREAD);
        
   //   
   if (bars_n<=1 || indent<=0 || ticket==0 || !OrderSelect(ticket,SELECT_BY_TICKET) || !IsTradeAllowed())
   {
   //Print("  TrailingByShadows()  -     .");
   return;
   } 
   
   //    (OP_BUY),   bars_n 
   if (typ==OP_BUY)
   {
        new_extremum = iLow(smb,tmfrm,iLowest(smb, tmfrm, MODE_LOW, bars_n, 1));
        newsl=NormalizeDouble(new_extremum - indent*point,digits);     
      //      
      if (trlinloss==true)
      {
         //    ""   ,  
         if ((newsl>osl || osl==0) && newsl<(bid-stoplevel*point))
         if(newsl!=osl)
         if (!OrderModify(ticket,oop,newsl,otp,0,NULL))            
         Print("    ",ticket,". : ",GetLastError());
      }
      else
      {
         //       ,     
         if ((newsl>osl || osl==0) && newsl>oop && newsl<(bid-stoplevel*point))
         if(newsl!=osl)
         if (!OrderModify(ticket,oop,newsl,otp,0,NULL))            
         Print("    ",ticket,". : ",GetLastError());
      }
   }
      
   //    (OP_SELL),   bars_n 
   if (typ==OP_SELL)
   {
        new_extremum = iHigh(smb,tmfrm,iHighest(smb, tmfrm, MODE_HIGH, bars_n, 1));
        newsl=NormalizeDouble(new_extremum + (indent + spread)*point,digits);     
      //      
      if (trlinloss==true)
      {
         //    ""   ,  
         if ((newsl<osl || osl==0) && newsl>(ask+stoplevel*point))
         if(newsl!=osl)
         if (!OrderModify(ticket,oop,newsl,otp,0,NULL))            
         Print("    ",ticket,". : ",GetLastError());
      }
      else
      {
         //       ,     
         if ((newsl<osl || osl==0) && newsl<oop && newsl>(ask+stoplevel*point))
         if(newsl!=osl)
         if (!OrderModify(ticket,oop,newsl,otp,0,NULL))            
         Print("    ",ticket,". : ",GetLastError());
      }      
   }      
}
//+------------------------------------------------------------------+